package com.goafanti.common.dao;

import com.goafanti.common.model.TaskDetails;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 项目申报详情(TaskDetails)表数据库访问层
 *
 * @author makejava
 * @since 2024-12-26 17:11:50
 */
public interface TaskDetailsMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TaskDetails selectById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param taskDetails 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<TaskDetails> findTaskDetailsList(TaskDetails taskDetails, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param taskDetails 查询条件
     * @return 总行数
     */
    int findTaskDetailsCount(TaskDetails taskDetails);

    /**
     * 新增数据
     *
     * @param taskDetails 实例对象
     * @return 影响行数
     */
    int insert(TaskDetails taskDetails);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TaskDetails> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TaskDetails> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TaskDetails> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TaskDetails> entities);

    /**
     * 修改数据
     *
     * @param taskDetails 实例对象
     * @return 影响行数
     */
    int update(TaskDetails taskDetails);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    TaskDetails selectByTid(Integer id);
}

